﻿using System.Runtime.Serialization;
using System.Windows.Media;
using MouseExtender.Controls.UserControls;

namespace MouseExtender.Logic.Entities
{
    /// <summary>
    /// Class represent tab metadata
    /// </summary>
    [DataContract]
    public class TabInfo
    {
        /// <summary>
        /// Tab identificator
        /// </summary>
        [DataMember]
        public int Id
        {
            get;
            set;
        }

        /// <summary>
        /// Tab name (displayed at the top of application window)
        /// </summary>
        [DataMember]
        public string Name
        {
            get;
            set;
        }

        /// <summary>
        /// Tab display color
        /// </summary>
        public Color Color
        {
            get;
            set;
        }

        /// <summary>
        /// Tab index (is needed to make a tab switch in proper direction)
        /// </summary>
        public int OrderIndex
        {
            get;
            set;
        }

        public LauncherItemUC ContextMenuOwner
        {
            get;
            set;
        }
    }
}