﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using MouseExtender.Logic.Entities;

namespace MouseExtender.Logic.Events
{
    public delegate void LaunchItemSelected(object sender, LaunchItemSelectedEventArgs e);

    public class LaunchItemSelectedEventArgs : EventArgs
    {
        public LaunchItemSelectedEventArgs(LauncherItem launcherItem)
            : this(launcherItem, false)
        {
        }

        public LaunchItemSelectedEventArgs(LauncherItem launcherItem, bool isMultipleSelect)
        {
            LauncherItem = launcherItem;
            IsMultipleSelect = isMultipleSelect;
        }

        public LauncherItem LauncherItem
        {
            get;
            private set;
        }

        public bool IsMultipleSelect
        {
            get;
            private set;
        }
    }
}
